	;
	; Common set of routines.
	; These stay in the memory at all time.
	;
ptr	= $D0
save_a	= $20
save_x	= $21
save_y	= $22
shutdown	= $23

fade_text_count		= $DE
fade_text_flash_count	= $DF
fade_text_width		= $E0
fade_text_ptr		= $E2
fade_text_ptr2		= $E4
fade_text_positions	= $E6

screen_off
	LDY #$00
	;
screen_off_2
	JSR shutdown_check
	;
	JSR sync_bottom
	;
	STY $FF19
	;
	LDA #$00
	STA $FF06
	;
play_only
	LDX #music_only_irq1 & 255
	LDY #music_only_irq1 >> 8
	LDA #$10
	;
set_irq	;
	SEI
	STX $FFFE
	STY $FFFF
	STA $FF0B
	INC $FF09
	CLI      
	;
	RTS
	;
	; -----------
	;         
sync_cc
	LDA #$CC
	DB $2C
sync_bottom
last_line_value
	LDA #$FF	; modified for NTSC
sync_any
	LDX #$A8
cs_sync	CMP $FF1D
	BNE *-3
	;
	CPX $FF1E
	BCC *-3
	RTS
	;
	; -----------
	;
music_only_irq1
	STA save_a
	STX save_x
	STY save_y
	;
	;DEC $FF19
	JSR PLAYER
	;INC $FF19
	;
	LDA #$B0
	LDX #music_only_irq2 & 255
	BNE music_only_irq_set
	;
music_only_irq2
	STA save_a
	STX save_x
	STY save_y
	;
	;DEC $FF19
	JSR PLAYER_SOUND
	;INC $FF19
	;
	JSR space_check
	;                     
	LDA #$10              
	LDX #music_only_irq1 & 255
	;
music_only_irq_set
	STA $FF0B
	STX $FFFE
	;
	LDA save_a
	LDX save_x
	LDY save_y
	;
	INC $FF09
	;
	RTI
	;
	; -----------
	;
space_check
	LDA #$7F
	STA $FD30
	STA $FF08
	LDA $FF08
	AND #$10	; Query keyboard for "Space"
	BNE not_pressed
	;
	LDA #$01
	STA shutdown	; set the flag
	;
not_pressed
	RTS

shutdown_check
	LDA shutdown
	BEQ sc_1
	;
	JMP all_over
	;
sc_1	RTS	
	
	;
	; -----------
	; fills a section of the memory with the same byte
	;
	; A = byte to fill
	; X = pages       
	; Y = high byte of address
	;
	; on exit: Y=$00, X=$FF
	;
fill3	LDX #$03	; common entry: fill 4 pages
fill	STY ptr+1
	LDY #$00
	STY ptr
	;	
	; enter from this point to continue fill from last place
	;
fillc	STA (ptr),y	; unroll the loop a bit to gain speed
	INY
	STA (ptr),y
	INY
	STA (ptr),y
	INY
	STA (ptr),y
	INY
	;
	STA (ptr),y
	INY
	STA (ptr),y
	INY
	STA (ptr),y
	INY
	STA (ptr),y
	INY
	;
	BNE fillc
	INC ptr+1
	DEX
	BPL fillc
	;
	RTS