	;
	; Produces the background for the last part.
	; Also the writing on the screen.
	;
STANDALONE=0

g_ptr1 = $E0
g_ptr2 = $E2

letter_tmp	= $D7
letter_tmp1	= $D8
letter_tmp2	= $D9
back_x		= $DA

text_dest	= $DC
text_source	= $DE

bg_count	= $A0
bg_delay	= $A1
lpos		= $A2
	
	if STANDALONE=1
	ORG $1001-2
	DW  $1001
	
	DW $100B,0
	DB $9E,"4109",0,0,0
	endif
	
gfxback_start
	if STANDALONE=1
	SEI
	STA $FF3F
	;
	LDA #$00
	STA $23 ; shutdown
	;
	endif
	;
	JSR screen_off
	SEI
	;
	LDA #$71
	STA $FF16
	;       
	LDA #$00
	STA $FF15
	LDY #$08
	LDX #$07
	JSR fill
	;
	STY g_ptr1	; y=$00
	LDA #$20
	STA g_ptr1+1
	;
gfx_cl2	LDY #$0F
gfx_cl1	LDA pattern,y
	STA (g_ptr1),y
	DEY
	BPL gfx_cl1
	;
	LDA g_ptr1
	CLC
	ADC #$10
	STA g_ptr1
	BCC *+4
	INC g_ptr1+1
	LDA g_ptr1+1
	CMP #$40
	BNE gfx_cl2
	;
	; --- apply corner mask
	;
	LDX #$00       
	;
	LDY #$20
	LDA #$04
	JSR mask_corner
	;
	LDY #$21
	LDA #$34
	JSR mask_corner
	;
	LDY #$3C
	LDA #$C0
	JSR mask_corner
	;
	LDY #$3D
	LDA #$F0
	JSR mask_corner
	;
	; ---
	JSR sync_cc
	;
	LDA #$C8
	STA $FF12
	;
	LDA #$33	; 24 rows
	STA $FF06
	;    
	LDA $FF07
	AND #$40
	ORA #$18
	STA $FF07
	;
	; ---
	;
	LDA #$FF
	STA bg_count
	LDA #$48-1
	STA bg_delay
	;
	; ---
	;
	LDA #$18
	STA text_dest
	LDA #$2A
	STA text_dest+1
	;
	LDA #final_text & 255
	STA text_source
	LDA #final_text >> 8
	STA text_source+1
	;
	if STANDALONE=1
	JMP *
	else
	JMP digi_start
	endif      
	
mask_corner   
	STY g_ptr1+1
	STA g_ptr1
	CLC
	ADC #$3C
	STA g_ptr2
	LDA g_ptr1+1
	ADC #$01
	STA g_ptr2+1
	;
	LDY #$00
	;
mc1	LDA (g_ptr1),y
	AND corner_mask,x
	STA (g_ptr1),y
	;
	LDA (g_ptr2),y
	AND corner_mask+4*16,x
	STA (g_ptr2),y
	INX
	INY
	CPY #16
	BNE mc1
	;
	RTS
	;

	; coordinates, randomized	
bg_ptr
	DW $0940 + 16	; pointer to color memory
	DB $30		; color shift
	DW $0800
	DB $30
	DW $0940 + 32
	DB $40
	DW $0800 + 24
	DB $48
	DW $0A80 + 32
	DB $30
	DW $0940  
	DB $20
	DW $0800 + 32
	DB $50
	DW $0940 + 8
	DB $28
	DW $0A80 + 24
	DB $28
	DW $0800 + 8
	DB $38
	DW $0A80
	DB $10
	DW $0800 + 16
	DB $40
	DW $0A80 + 8
	DB $18
	DW $0940 + 24
	DB $38
	DW $0A80 + 16
	DB $20
	
draw_background
	LDX bg_delay
	INX
dbg2	CPX #$48
	BNE dbg1
	;
	DEX
	LDA bg_count
	CMP #14
	BNE dbg5
	;
	LDA dbg4
	CMP #$2C
	BNE dbg1
	;
tfo0	LDY #$00	; do final text fade out, just keep changing $FF16
	LDA text_fade_out,y
	STA $FF16         
	CPY #text_fade_out_end - text_fade_out-  1
	BEQ tfo1
	INY
	STY tfo0+1
	;
tfo1	JMP dbg1
	;
	; ---
	;       
dbg5	LDA dbg2+1	; alternate delay between $18 (one beat) and $48 (three beats)
	EOR #($18^$48)
dbg4	STA dbg2+1
	;
	INC bg_count	; at every 24 frames, look up next pointer
	LDA bg_count
	ASL a
	ADC bg_count	; *3
	TAY
	;
	LDA bg_ptr,y	; lo byte
	STA g_ptr1
	STA g_ptr2  
	;
	LDA bg_ptr+1,y	; hi byte
	STA g_ptr1+1
	ORA #$04
	STA g_ptr2+1
	;
	LDA bg_ptr+2,y
	STA back_x
	;
	LDA bg_ptr+3,y
	STA back_x_end+1
	;            
	LDX #$00
dbg1	STX bg_delay
	;
	CPX #$08	; only do drawing in the first 8 frames
	BCS dbg_done	; (draw exactly 8 lines, then pause for music tempo)
	;
	LDX back_x
back_x_end
	CPX #$00
	;
	LDY #$00
ll1	LDA bg_lum,x
	STA (g_ptr1),y
	LDA bg_col,x
	STA (g_ptr2),y
	INX
	INY
	CPY #8
	BNE ll1
	;
	LDA #$28
	;TYA
	CLC
	ADC g_ptr1
	STA g_ptr1
	STA g_ptr2
	BCC *+6
	INC g_ptr1+1
	INC g_ptr2+1
	;
	DEC back_x
	DEC back_x  
	;
dbg_done
	;
	RTS

wl_next_line
	LDA #$78		; (skip a line + 8 chars)
	JSR add_x
	JMP wl_done1
	;	
write_next_letter
	LDY #$00
	LDA (text_source),y
	BEQ wl_next_line	; 00 means skip one line down
	;       
	CMP #$FF		; end of text marker
	BNE write_letter
	;
	LDX #88
	LDA #$00
wl_10	STA bg_col,x
	DEX
	BPL wl_10
	;
	STX bg_count		; x = $FF, reset background stuff
	LDA #23
	STA bg_delay 
	;
	LDA #$60		; RTS opcode
	STA write_next_letter	; self-mod
	;
	LDA #$2C		; BIT $0000 opcode, this "nop"s out the part
	STA dbg4		; that delays the boxes, so they appear on each beat now
	;
	JMP wl_done2		; X=$FF, important because digi starts volume down
	;  
	; *** writes one letter on screen
	;     letter is expected in "A"
	;     uses Y, leaves X
	;
write_letter
	CMP #$94		; "t"
	BNE wl_02
	;
	LDY #letter_t & 255
	LDA #letter_t >> 8
	BNE wl_05
	;
wl_02	CMP #$8B		; "k"
	BNE wl_06
	;
	LDY #letter_k & 255
	LDA #letter_k >> 8
	BNE wl_05
	;
wl_06	
;	CMP #"'"		; single quote
;	BNE wl_08
;	;
;	LDY #letter_quote & 255
;	LDA #letter_quote >> 8
;	BNE wl_05
;	;
;wl_08	
	CMP #$8C		; :"l"
	BNE wl_04
	;
	LDY #letter_l & 255
	LDA #letter_l >> 8
	;
wl_05	STY lpos+0
	STA lpos+1
	BNE wl_03
	;
wl_04	STA lpos+0		; store letter
	;
	LDA #$D0 >> 3		; address is $D000 + letter * 8
	STA lpos+1
	;
	ASL lpos+0		; * 8 (16bit)
	ROL lpos+1
	ASL lpos+0
	ROL lpos+1
	ASL lpos+0
	ROL lpos+1
	;
wl_03
wl_y	LDY #$00		; copy!
lposl	
	JSR get_lbyte
	;
	;  
	CPY #$08
	BEQ no_outline
	;
	JSR draw_outline 	; outline above
	;
	JSR draw_outline	; middle
	;
	JSR draw_outline	; outline below 
	;
	JSR dest_pos_back
	;
no_outline
	LDY wl_y+1
	CPY #$00
	BEQ wl_07
	;    
	DEY
	JSR get_lbyte
	JSR next_line_check
	JSR next_line_check
	;
	LDA (text_dest),y	; outline on sides + draw letter
	ORA letter_tmp
	STA (text_dest),y
	;
	JSR dest_pos_back
	;
wl_07	LDX wl_y+1
	INX
	CPX #$09
	BNE wl_done2
	;
	LDA #$08		; go to next character position
	JSR add_n
	;
wl_done1
	LDA #$01		; go to next letter in source text
	CLC
	ADC text_source
	STA text_source  
	BCC *+4
	INC text_source+1
	;
	LDX #$00
	;
wl_done2
	STX wl_y+1
	RTS
	
get_lbyte
	LDA #$00
	STA letter_tmp1
	;
	SEI
	STA $FF3E
	LDA (lpos),y		; self-mod
	STA $FF3F
	CLI
	ASL a			; shift once, so the lines are on multicolor pixel boundary
	STA letter_tmp2
	AND #$AA
	STA letter_tmp
	LDA letter_tmp2
	ASL a
	AND #$AA
	AND letter_tmp		; keep only full pixels
	STA letter_tmp
	LSR a
	ORA letter_tmp
	STA letter_tmp
	;
	STA letter_tmp2
	LSR a			; mask right
	LSR a          
	ORA letter_tmp2
	STA letter_tmp2
	;
	ASL letter_tmp2		; mask left (16 bit)
	ROL letter_tmp1
	ASL letter_tmp2
	ROL letter_tmp1
	;
	ORA letter_tmp2
	EOR #$FF		; invert mask
	STA letter_tmp2
	;              
	LDA letter_tmp1
	EOR #$FF
	STA letter_tmp1
	;
nlc_1	RTS
	
draw_outline
	JSR next_line_check
	;
	LDA (text_dest),y	; draw outline
	AND letter_tmp2
	STA (text_dest),y
	;
	LDA text_dest		; go back
	SEC
	SBC #$08
	STA text_dest
	BCS *+4
	DEC text_dest+1
	;
	LDA (text_dest),y	; draw outline
	AND letter_tmp1
	STA (text_dest),y
	;
	LDA #$08
	JMP add_n
	
next_line_check
	INY
	CPY #$08
	BNE nlc_1
	;
add320	LDA #$38
add_x	INC text_dest+1
add_n	CLC
	ADC text_dest		; +320 to pointer, goes to next line
	STA text_dest
	BCC *+4        
	INC text_dest+1
	RTS
	
dest_pos_back
	CPY #$08
	BCC dpb1
	;
	LDA text_dest		; go back
	SEC
	SBC #$38
	STA text_dest
	BCS *+4
	DEC text_dest+1
	DEC text_dest+1
	;
dpb1	RTS

corner_mask
	; 32*16 m
	DB $00,$00,$03,$0F,$FF,$FF,$FF,$FF,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	DB $F0,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00,$00,$C0,$F0,$FF,$FF,$FF,$FF
	DB $3F,$3F,$3F,$0F,$0F,$03,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$0F
	DB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$F0,$FC,$FC,$FC,$F0,$F0,$C0,$00,$00
	;
	DB $0F,$3F,$3F,$3F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	DB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F0,$FC,$FC,$FC,$FF,$FF,$FF,$FF
	;DB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	;DB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	
pattern
	;DB $99,$99,$66,$66,$55,$55,$55,$55
	;DB $AA,$AA,$AA,$AA,$99,$99,$66,$66
	
	DB $56,$59,$66,$9A,$55,$55,$55,$55
	DB $AA,$AA,$AA,$AA,$56,$59,$66,$9A
	
	;DB $66,$59,$66,$59,$55,$55,$55,$55
	;DB $AA,$AA,$AA,$AA,$66,$59,$66,$59
	
	;DB $2,$2B,$4,$E,$6,$D,$3,$C,$5,$F,$A,$7,$9,$8
	
bg_col
	DB $88,$88,$88,$88,$88,$88,$89,$89,$99,$99,$99,$99
	DB $99,$99,$97,$97,$77,$77,$77,$77,$77,$77,$77,$77
	DB $77,$77,$7A,$7A,$AA,$AA,$AF,$AF,$FF,$FF,$FF,$FF
	DB $F5,$F5,$55,$55,$55,$55,$55,$55,$5C,$5C,$CC,$CC
	DB $CC,$CC,$CC,$CC,$C3,$C3,$33,$33,$33,$33,$3D,$3D
	DB $DD,$DD,$DD,$DD,$D6,$D6,$66,$66,$66,$66,$6E,$6E
	DB $E4,$E4,$44,$44,$44,$44,$44,$44,$4B,$4B,$BB,$BB
	DB $BB,$BB,$B2,$B2
	
bg_lum
	DB $56,$56,$45,$45,$34,$34,$23,$23,$12,$12,$01,$01
	DB $10,$10,$21,$21,$32,$32,$43,$43,$54,$54,$65,$65
	DB $56,$56,$45,$45,$34,$34,$23,$23,$12,$12,$01,$01
	DB $10,$10,$21,$21,$32,$32,$43,$43,$54,$54,$65,$65
	DB $56,$56,$45,$45,$34,$34,$23,$23,$12,$12,$01,$01
	DB $10,$10,$21,$21,$32,$32,$43,$43,$54,$54,$65,$65
	DB $56,$56,$45,$45,$34,$34,$23,$23,$12,$12,$01,$01
	DB $10,$10,$21,$21 ; ,$32,$32,$43,$43,$54,$54,$65,$65
	
	;DB $67,$67,$56,$56,$45,$45,$34,$34,$23,$23,$12,$12,$01,$01
	;DB $10,$10,$21,$21,$32,$32,$43,$43,$54,$54,$65,$65,$76,$76
	;DB $67,$67,$56,$56,$45,$45,$34,$34,$23,$23,$12,$12,$01,$01
	;DB $10,$10,$21,$21,$32,$32,$43,$43,$54,$54,$65,$65,$76,$76
	;DB $67,$67,$56,$56,$45,$45,$34,$34,$23,$23,$12,$12,$01,$01
	;DB $10,$10,$21,$21,$32,$32,$43,$43,$54,$54,$65,$65,$76,$76
	;DB $67,$67,$56,$56,$45,$45,$34,$34,$23,$23,$12,$12,$01,$01
	;DB $10,$10,$21,$21,$32,$32,$43,$43,$54,$54,$65,$65,$76,$76

	if STANDALONE=1
PLAYER
PLAYER_SOUND          
all_over
	RTS
	;
	include "common1.asm"
	endif
	
	CMAP "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	CMAP "a",$81,$82,$83,$84,$85,$86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$8F,$90,$91,$92,$93,$94,$95,$96,$97,$99,$99,$9A,$9B
final_text
	DB " So do not believe the pig herder",0
	DB "  He says the plink is all stink ",0
	DB "    But the Plussy  cannot die   ",0
	DB "As long as YOU listen to the plink"
	DB "                                     ",$FF
	CMAP	; clear cmap settings

letter_t
	DB $18,$18,$7e,$18,$18,$18,$06,$00
letter_k
	DB $60,$60,$66,$66,$78,$66,$66,$00
letter_l
	DB $18,$18,$18,$18,$18,$18,$06,$00
;letter_quote
;	DB $18,$18,$60,$00,$00,$00,$00,$00
	
	; final fade out colors
text_fade_out
	DB $61,$71,$61,$71,$61,$61
	DB $51,$61,$51,$61,$51,$51
	DB $41,$51,$41,$51,$41,$41
	DB $31,$41,$31,$41,$31,$31
	DB $21,$31,$21,$31,$21,$21
	DB $11,$21,$11,$21,$11,$11
	DB $01,$11,$01,$11,$01,$01
	DB $00,$01,$00
text_fade_out_end
	;
	