	;
	; This was the first version of the NOTES part.
	; Originally it masked the two waves,
	; but I used a faster and simpler method in the end.
	;
STANDALONE=1

	if STANDALONE=1
	ORG $1001-2
	DW  $1001
	
	DW $100B,0
	DB $9E,"4109",0,0,0
	endif
	
notes_ptr	= $D0
scrl	= $E0
store	= $E1
notec	= $E2
source1	= $E4
source2	= $E6
newchar_dest	= $E8

charset	= $3800
notes_sin2	= charset + $200
notes_sin3	= charset + $300
mul8_lo	= charset + $400
mul8_hi	= charset + $500
	
; start
	if STANDALONE=1
	JSR $FF4F
	DB $93
	DB 0
	;
	SEI
	STA $FF3F
	;
	; ---------
	LDA #$00
	STA $FF12
	endif
	;
	LDA $FF07
	AND #$40
	STA notes_ntsc+1
	;
	LDX #$46
	STX $FF19
	STX $FF15
	;
	LDA #$00
	STA scrl
	;
	;
	; --- clear screen
	;          
	LDX #$03
	LDA #$02
	LDY #$0C
	JSR fill
	;       
	TYA
	LDY #charset >> 8	; clear charset
	if STANDALONE=1
	STY $FF13
	endif
	LDX #$01
	JSR fill
	;                
	; --- make 8 versions of the "sprite"
	;
	;LDY #$00
nc2	LDX #$0F
nc1	LDA one_note,x
	STA charset,y
	INY
	DEX
	BPL nc1
	;
	TYA
	CLC
	ADC #$09
	TAY
	CPY #$C0
	BCC nc2
	;
	LDY #$01
	JSR copy_note
	LDY #8+8-2
	JSR copy_note
	;
	LDY #$03 + 6*8
	JSR copy_note
	LDY #$23 + 6*8
	JSR copy_note
	;
	LDY #$03 + 12*8
	JSR copy_note
	LDY #$23 + 12*8
	JSR copy_note
	;
	;
	; --- convert notes_sin1 table
	;                  
	LDX #$00
sl1	LDA notes_sin1,x
	LSR a
	LSR a
	LSR a 
	TAY
	LDA mul40,y
	CLC
	ADC #$17		; add low byte of screen pos
	STA notes_sin2,x
	;
	LDA notes_sin1,x
	AND #$07
	STA plus1+1
	ASL a   
	CLC
plus1	ADC #$00
	STA notes_sin3,x
	INX
	BNE sl1
	;
	LDX #$00
	STX mul8_lo
	LDA #charset >> 8
	STA mul8_hi
	;
il1	LDA mul8_lo,x
	CLC
	ADC #$08
	STA mul8_lo+1,x
	LDA mul8_hi,x
	ADC #$00
	STA mul8_hi+1,x
	;
	INX
	CPX #$FF
	BNE il1
	;     
	; ---------
	;
nsync0	LDA $FF1D
	CMP #$7C
	BNE nsync0
	;
	DEC $FF19
	;
	LDA scrl
notes_ntsc
	ORA #$00
	STA $FF07
	;
	; -- init or routine
	;
	LDA #$20
	STA newchar+1
	LDA #$00
	STA newchar_dest
	LDA #(charset >> 8) + 1
	STA newchar_dest+1
	;
	LDX #39
	LDA #$02
cl2	STA $0D17,x
	STA $0D17+1*40,x
	STA $0D17+2*40,x
	STA $0D17+3*40,x
	STA $0D17+4*40,x
	STA $0D17+5*40,x
	STA $0D17+6*40,x
	STA $0D17+7*40,x
	DEX
	BNE cl2
	;
start_x1
	LDX #$00
note_loop
	LDY #$0D		; high byte of position of effect, $0D17
	STY notes_ptr+1
	;  
	TXA
	CLC
sin_notes_ptr
	ADC #$00
	TAY
	;  
	TXA
	CLC
	ADC notes_sin2,y
	;ADC #$17		; low byte of position of effect, $0D17
	STA notes_ptr
	BCC *+4
	INC notes_ptr+1
	;        
	LDA notes_sin3,y	; draw one note
	LDY #0
	STA (notes_ptr),y	; top char
	;
	LDY #40
	CLC
	ADC #$01
	STA (notes_ptr),y	; 2nd char one line below
	;
	LDY #80
	;CLC
	ADC #$01
	STA (notes_ptr),y	; 3rd char two lines below
	;  
	INX
note_count
	CPX #$01		; length (or number of notes), self-mod
	BNE note_loop
	;
	; ---       
	;
start_x2
	LDX #$00
note2_loop
	LDY #$0D		; high byte of screen position
	STY notes_ptr+1
	;
	TXA
	CLC
	ADC #sin_wavelength >>1	; shift sinus pointer
sin2_notes_ptr
	ADC #$00
	TAY
	;
	TXA
	CLC
	ADC notes_sin2,y
	;ADC #$17		; low byte of screen pos
	STA notes_ptr
	BCC *+4
	INC notes_ptr+1
	;        
	LDA notes_sin3,y
	LDY #0			; top char
	STA store
	JSR orput
	;
	LDY #40			; 2nd char     
	INC store
	JSR orput
	;
	LDY #80			; 3rd char     
	INC store
	JSR orput
	;  
	INX
note2_count
	CPX #$01		; length (or number of notes), self-mod
	BNE note2_loop
	;                
	; ---       
	;
	LDY scrl		; keep scrolling screen
	INY
	CPY #$08
	BEQ swrap
	;
	STY scrl
	;
	LDA sin_notes_ptr+1     
	CLC
	ADC #$01
	CMP #sin_wavelength
	BNE *+4
	LDA #$00
	STA sin_notes_ptr+1
	;
	;
	LDA sin2_notes_ptr+1     
	CLC
	ADC #$01
	CMP #sin_wavelength
	BNE *+4
	LDA #$00
	STA sin2_notes_ptr+1
	;
	JMP s_nowrap2
	;	
swrap	LDY #$00
	STY scrl
	;
	LDA note_count+1
	CMP #$29
	BEQ s_nowrap1
	INC note_count+1
	JMP s_nowrap2
s_nowrap1
	;
	LDA note2_count+1
	CMP #$29
	BEQ s_nowrap3
	INC note2_count+1
	JMP s_nowrap2
s_nowrap3
	LDA start_x1+1
	CMP #$28
	BEQ s_nowrap4
	INC start_x1+1
	JMP s_nowrap2
s_nowrap4
	LDA start_x2+1
	CMP #$28
	BEQ s_nowrap2
	INC start_x2+1
	;
s_nowrap2
	;            
	INC $FF19        
	;
	JMP nsync0
	
orput	LDA (notes_ptr),y	; get current char from screen
	CMP #$02		; space?
	BEQ put 
	BNE put
	CMP #$15		; space?
	BEQ put 
	;
	STA ysave+1
	;
newchar	LDA #$20		; store new char on screen
	STA (notes_ptr),y
	;
ysave	LDY #$00
	LDA mul8_lo,y
	STA source1
	LDA mul8_hi,y
	STA source1+1
	;
	LDY store    
	LDA mul8_lo,y
	STA source2
	LDA mul8_hi,y
	STA source2+1
	;
	LDY #$07		; mix the two chars
	;
	LDA (source1),y
	ORA (source2),y
	STA (newchar_dest),y
	DEY
	;
	LDA (source1),y
	ORA (source2),y
	STA (newchar_dest),y
	DEY
	;
	LDA (source1),y
	ORA (source2),y
	STA (newchar_dest),y
	DEY
	;
	LDA (source1),y
	ORA (source2),y
	STA (newchar_dest),y
	DEY
	;
	LDA (source1),y
	ORA (source2),y
	STA (newchar_dest),y
	DEY
	;
	LDA (source1),y
	ORA (source2),y
	STA (newchar_dest),y
	DEY
	;
	LDA (source1),y
	ORA (source2),y
	STA (newchar_dest),y
	DEY
	;
	LDA (source1),y
	ORA (source2),y
	STA (newchar_dest),y
	;
	INC newchar+1		; use next character next time
	LDA newchar_dest	; inc desc pointer by 8
	CLC
	ADC #$08
	STA newchar_dest
	;   
	RTS
	;
put	LDA store
	CMP #$15
	BEQ put2
	STA (notes_ptr),y
put2	RTS
	
copy_note
	LDX #$0F
nc3	LDA one_note,x
	STA charset+$100,y
	INY
	DEX
	BPL nc3
	RTS
	
one_note
;	DB $08,$0C,$0A,$09,$09,$0A,$08,$08
;	DB $08,$08,$08,$08,$78,$F8,$F8,$70
	;   
	DB $70,$F8,$F8,$78,$08,$08,$08,$08
	DB $08,$0A,$09,$09,$0A,$0C,$08,$00
	;DB 0,0,0,0,0,0,0,0
	
mul40
	DB 0,40,80,120,160,200,240

	ALIGN 256
notes_sin1
sin_wavelength = 52
;52,23
	DB $17,$1A,$1D,$1F,$22,$24,$26,$28,$2A,$2B,$2D,$2D,$2E,$2E,$2E,$2D
	DB $2D,$2B,$2A,$28,$26,$24,$22,$1F,$1D,$1A,$17,$14,$11,$0F,$0C,$0A
	DB $08,$06,$04,$03,$01,$01,$00,$00,$00,$01,$01,$03,$04,$06,$08,$0A
	DB $0C,$0F,$11,$14
	
	DB $17,$1A,$1D,$1F,$22,$24,$26,$28,$2A,$2B,$2D,$2D,$2E,$2E,$2E,$2D
	DB $2D,$2B,$2A,$28,$26,$24,$22,$1F,$1D,$1A,$17,$14,$11,$0F,$0C,$0A
	DB $08,$06,$04,$03,$01,$01,$00,$00,$00,$01,$01,$03,$04,$06,$08,$0A
	DB $0C,$0F,$11,$14
	
	DB $17,$1A,$1D,$1F,$22,$24,$26,$28,$2A,$2B,$2D,$2D,$2E,$2E,$2E,$2D
	DB $2D,$2B,$2A,$28,$26,$24,$22,$1F,$1D,$1A,$17,$14,$11,$0F,$0C,$0A
	DB $08,$06,$04,$03,$01,$01,$00,$00,$00,$01,$01,$03,$04,$06,$08,$0A
	DB $0C,$0F,$11,$14
	
	if STANDALONE=1     
PLAYER
PLAYER_SOUND     
all_over
	RTS
	include "common1.asm"
	endif
	