	;
	; The Plasma part.
	;
	; This is actually two plasmas,
	; one for characters and one for colors.
	; The two are independent (look for "test" below).
	;
STANDALONE=0
IDEBUG=0
DEBUG=0

col_ptr		= $C0
lines		= $C4
cols		= $C5
bar_color	= $C6

plasma_pos	= $08A0

ntscdec	= 1	; reduce effect on ntsc by this many chars

final_colors = $2100
colors_start = $2200	; wipes out +$380 bytes

	if STANDALONE=1
 	ORG $1001 - 2
 	DW  $1001
	
	DW	as_next_line
	DB	$00,$00
	DB	$9E,"4124",$3A,$1B,$4A,"LEGI",$91," OF ",$EB,"OM",$00
as_next_line
	DB	$00,$00
	
	JMP plasma_start
	
	ORG $2800
	
PLAYER
PLAYER_SOUND
	RTS
	
	include "common1.asm"
	include "common2.asm"
	
	endif

plasma_start
	if IDEBUG=1
	LDA #$32
	STA $FF19
	endif 
	;
	if STANDALONE=1
	SEI
	STA $FF3F
	;
	JSR screen_off
	;
	LDA #$00
	LDY #$0C
	JSR fill3
	else
	JSR play_only
	endif
	;
	LDA $FF07
	AND #$40
	BEQ plasma_pal
	;
	LDX #39-ntscdec*2
	STX plasma_ntsc+1  
	LDX #(plasma_pos & 255) +ntscdec
	STX plasma_ntsc2+1
	;
plasma_pal
	ORA #$88
	STA reset_hscroll+1
	;
	if STANDALONE=1
	LDA #$00
	STA $FF12
	STA $FF15
	STA $FF19
	;
	LDY #$38
	STY $FF13
	;
	TAX			; fill one page at $3800 (charset)
	JSR fill
	endif
	;
	; --- ####################################
	;
	LDA #colors_start & 255	; init color pointer
	STA col_ptr
	LDA #colors_start >> 8
	STA col_ptr+1
	;
	LDX #$00
	STX lines
mb0	LDA bar_colors,x	; create raster bars that make up plasma
	STA bar_color
	;
	;JSR make_bar
;make_bar
	LDX #$00
	LDY #$00
mb1	LDA bar_shades,X
	ORA bar_color
	STA (col_ptr),Y
mb2	INY			; self-mod
	STA (col_ptr),Y
	INY
	INX
	CPX #$10
	BNE mb1
	;  
	TYA
	CLC
	ADC col_ptr
	STA col_ptr
	BCC *+4
	INC col_ptr+1
	;RTS
	;
	INC lines
	LDX lines   
	CPX #bar_switch - bar_colors - 1
	BNE mc2
	;
	LDA #$EA	; NOP opcode
	STA mb2
	;
mc2	CPX #bar_colors_start - bar_colors
	BNE mb0
	;
	ASL col_ptr		; col_ptr is $80, we need to set it to zero 
	;LDA col_ptr		; to go back $80 bytes in the table
	;SEC
	;SBC #$80	; back by $80 bytes
	;STA col_ptr
	;BCS *+4
	;DEC col_ptr+1
	;
	if IDEBUG=1
	LDA #$77
	STA $FF19
	endif
	;
	LDA #$44	; space char
	LDY #$0D
	LDX #$01
	JSR fill	; clear top part of screen
	;
	; ---------------------------------
	;
	STY fade_text_flash_count
	STY fade_text_count
	;
	LDA #plasma_text_positions & 255
	STA fade_text_positions
	LDA #plasma_text_positions >> 8
	STA fade_text_positions + 1
	;
	LDA #plasma_text_colors & 255
	STA fade_text_colors_ptr+1
	LDA #plasma_text_colors >> 8 
	STA fade_text_colors_ptr+2
	;
	if IDEBUG=1
	LDA #$33
	STA $FF19
	endif
	;
	; ---
	;
	LDY #$00	; fill colour memory to hide text
	LDA #$39	; same color as background
p1	STA wavef_pos-$0400,y
	STA inter_pos-$0400,y
	INY
	BPL p1
	;
	if IDEBUG=1
	LDA #$00
	STA $FF19
	endif
	;
	; ---
	;
	JSR sync_bottom
	;
	LDA #$39	; set border and background for first frame
	STA $FF19
	STA $FF15
	;
reset_hscroll
	LDA #$00
	STA $FF07
	;
	if STANDALONE=1
	LDA #$1B
	STA $FF06      
	endif
	;
	LDX #plasma_irq_1 & 255
	LDY #plasma_irq_1 >> 8
	LDA #$21
	JSR set_irq
	;
	LDA #$00
	JSR special_clear2
	;
wavef_width = $1B
wavef_pos = $0C06
would_pos = $0C11
inter_pos = $0F2E+80
	;
	LDX #wavef_width-1
mkcopy2	LDA makes_charmap+$23+164*0,x
	STA wavef_pos,x
	LDA makes_charmap+$23+164*1,x
	STA wavef_pos+40,x
	;
	LDA makes_charmap+$3F+164*0,x
	STA inter_pos+0,x
	LDA makes_charmap+$3F+164*1,x
	STA inter_pos+40,x
	LDA makes_charmap+$3F+164*2,x
	STA inter_pos+80,x
	;          
	DEX
	BPL mkcopy2
	;
	if IDEBUG=1
	LDA #$55
	STA $FF19
	endif
	;      
	; --- set plasma chars
	;
	INY
	TYA
pc1	STA final_colors,y
	INY
	BNE pc1  
	;
	; Plasma is done from main code
	; so raster lines can interrupt
	;
main_plasma_loop	
plasma_ntsc2
	LDA #plasma_pos & 255
	STA plasma_ptr+1
	STA plasma_ptr_2+1
	LDA #plasma_pos >> 8
	STA plasma_ptr+2  
	ORA #$04
	STA plasma_ptr_2+2
	;
	JSR sync_cc
	;
	if DEBUG=1
	DEC $FF19
	endif
	;
	LDA sin1+1
	CLC
	ADC #$01
	CMP #100
	BNE pl6
	LDA #$00
pl6	STA sin1+1
	;      
	LDA sin2+1
	SEC
	SBC #$01
	CMP #99+40-1
	BNE pl7
	LDA #$FF-40
pl7	STA sin2+1
	;
	LDA sin3+1
	CLC
	ADC #$01
	CMP #182
	BNE pl7_2
	LDA #$00
pl7_2	STA sin3+1
	;
	LDA #17
	STA lines
	;
pl4
	LDA lines
	CLC
sin1	ADC #10		; sinus start value
	TAX 
	;
	LDA lines
	;LSR a
	CLC
	ADC sinus,x
	;adc sinus2,x
	STA line_a+1
	;
	;CLC
	;ADC lines
	TAX
	LDA sinus2,x
	CLC
	ADC lines
	STA line_a_2+1
	;
interlace
plasma_ntsc
	LDY #39
pl3	
line_a	LDA #$00
sin2	ADC sinus2,y
	TAX
	LDA final_colors,x
	;LDA #$71		; uncomment this to test chars only!
plasma_ptr
	STA $0800,y
	;
line_a_2
	LDA #$00
sin3	ADC sinus3,y
	ORA #$E0		; chars from 0-F are getting fuller, then back to empty
	;			; so no lookup is needed
	;TAX
	;LDA chars,x
	;LDA #$0F 		; uncomment this to test colors only!
plasma_ptr_2
	STA $0C00,y
	;
	DEY
	DEY
	BPL pl3
	;
	LDA plasma_ptr+1	; inc plasma_ptr by 40
	CLC
	ADC #40
	STA plasma_ptr+1   
	STA plasma_ptr_2+1
	BCC pl5
	;
	INC plasma_ptr+2  
	INC plasma_ptr_2+2
pl5
	;
	;
	DEC lines
	BNE pl4 
	;
	LDA interlace+1
	EOR #$01       
	STA interlace+1
	;
	LDY #$7F
col_copy
	LDA (col_ptr),y
	STA final_colors,y
	DEY
	LDA (col_ptr),y
	STA final_colors,y
	DEY
	BPL col_copy 
	;
	LDA col_ptr
	SEC
	SBC #$01
	STA col_ptr
	BCS *+4
	DEC col_ptr+1
	;
	LDA col_ptr
	CMP #colors_start & 255
	BNE colors_not_end
	LDA col_ptr+1
	CMP #colors_start >> 8
	BEQ plasma_over
	;                 
colors_not_end
	;            
	JSR fade_text
	;
	if DEBUG=1
	INC $FF19
	endif
	;
	JMP main_plasma_loop
	
plasma_over
	if STANDALONE=1
	JMP *
	else
	;
	JMP squares_start
	endif
	
	if STANDALONE=1
	ALIGN 256
	endif
	
plasma_irq_1
	STA save_a
	STX save_x
	STY save_y
	;
	LDX #$71
	;
	LDY #$A8
	CPY $FF1E
	BCS *-3
	;
	if DEBUG=1
	STX $FF16
	STX $FF16
	else
	STX $FF19
	STX $FF15
	endif
	;
	LDX #$00
	;
	LDA #$22
	CMP $FF1D
	BNE *-3
	;
	CPY $FF1E
	BCS *-3
	;
	if DEBUG=1
	STX $FF16
	STX $FF16
	else
	STX $FF19
	STX $FF15
	endif
	;
	;DEC $FF19
	JSR PLAYER
	;INC $FF19
	;
	LDA #$AB
	LDX #plasma_irq_2 & 255
	BNE plasma_irq_set
	;
plasma_irq_2
	STA save_a
	STX save_x
	STY save_y
	;
	NOP
	NOP
	;        
	LDX #$71
	;
	LDY #$A8
	CPY $FF1E
	BCS *-3
	;
	if DEBUG=1
	STX $FF16
	STX $FF16
	else
	STX $FF19
	STX $FF15
	endif
	;
	LDX #$39
	;
	LDA #$AD
	CMP $FF1D
	BNE *-3
	;
	CPY $FF1E
	BCS *-3
	;
	if DEBUG=1
	STX $FF16
	STX $FF16
	else
	STX $FF19
	STX $FF15
	endif
	;
	;if DEBUG=1
	;DEC $FF19
	;endif
	JSR PLAYER_SOUND
	;if DEBUG=1
	;INC $FF19
	;endif
	;
	JSR space_check
	;                     
	LDA #$21
	LDX #plasma_irq_1 & 255
	;
plasma_irq_set
	STA $FF0B
	STX $FFFE
	;
	LDA save_a
	LDX save_x
	LDY save_y
	;
	INC $FF09
	;
	RTI
	
bar_shades
	DB $00,$10,$20,$30,$40,$50,$60,$70	; 8 shades
	DB $70,$60,$50,$40,$30,$20,$10,$00
	
bar_colors
	DB 0,0,0,0		; ending 8 shades of black :-)
	DB 1
	DB $2,$B,$4,$4,$E,$6,$D,$3,$3,$C,$5,$F,$A,$7,$9,$8
bar_switch
	DB 6,7,5,8,5,3
	DB 1
	DB 0,0,0,0, 0,0,0,0	; starting 8 shades of black
bar_colors_start
	
plasma_text_positions
	DW $0000		; does nothing, pause
	DB 0			; format: 2 bytes for position, one byte for width
	DW $0000
	DB 0
	DW $0000
	DB 0
	DW $0000
	DB 0
	DW wavef_pos   -$0400	; -$0400 is needed to point to color memory instead of character memory
	DB 9
	DW $0000
	DB 0
	DW wavef_pos+11-$0400	; top 4 words
	DB 5
	DW wavef_pos+17-$0400
	DB 4
	DW wavef_pos+23-$0400
	DB 3
	DW $0000
	DB 0
	DW inter_pos   -$0400	; bottom 1 word
	DB 9
	DW $0000
	DB 0
	DW $0000
	DB 0
	DW $0000
	DB 0
	DW $0000
	DB 0
	DW $0000
	DB 0
	;
plasma_text_colors
	DB $39,$49,$39,$49,$39	; from dark yellow to light yellow then white
	DB $49,$39,$49,$39,$49	; length is adjusted to match tempo of music
	DB $49,$49,$49,$49,$49
	DB $49,$59,$49,$59,$49
	DB $59,$49,$59,$49,$59
	DB $49,$59,$59,$59,$59
	DB $69,$59,$69,$69,$69
	DB $79,$69,$79,$79,$79
	DB $71,$71,$71,$71,$71,$71,$71,$71
plasma_text_colors_end
	
;	align 256
;chars
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
;	DB $0F,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02,$01,$00
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
;	DB $0F,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02,$01,$00
;	;
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
;	DB $0F,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02,$01,$00
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
;	DB $0F,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02,$01,$00
;	;
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	;
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	;
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	;
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
;	DB $0F,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02,$01,$00
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
;	DB $0F,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02,$01,$00
;	;
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
;	DB $0F,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02,$01,$00
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
;	DB $0F,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02,$01,$00
;	;
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
;	DB $0F,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02,$01,$00
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F
;	DB $0F,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02,$01,$00
;	;
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
;	DB $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	;
	; ---
	;
;colors_start
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	
;	DB $01,$01,$01,$01,$11,$11,$11,$11,$21,$21,$21,$21,$31,$31,$31,$41
;	DB $41,$31,$31,$31,$21,$21,$21,$21,$11,$11,$11,$11,$01,$01,$01,$01
;	DB $01,$01,$11,$11,$21,$21,$31,$31,$41,$41,$51,$51,$61,$61,$71,$71
;	DB $71,$71,$61,$61,$51,$51,$41,$41,$31,$31,$21,$21,$11,$11,$01,$01
;	
;	DB $0C,$1C,$2C,$3C,$4C,$5C,$6C,$7C,$7C,$6C,$5C,$4C,$3C,$2C,$1C,$0C
;	DB $06,$16,$26,$36,$46,$56,$66,$76,$76,$66,$56,$46,$36,$26,$16,$06
;	DB $08,$18,$28,$38,$48,$58,$68,$78,$78,$68,$58,$48,$38,$28,$18,$08
;	DB $0B,$1B,$2B,$3B,$4B,$5B,$6B,$7B,$7B,$6B,$5B,$4B,$3B,$2B,$1B,$0B
;	
;	DB $07,$17,$27,$37,$47,$57,$67,$77,$77,$67,$57,$47,$37,$27,$17,$07
;	DB $08,$18,$28,$38,$48,$58,$68,$78,$78,$68,$58,$48,$38,$28,$18,$08
;	DB $05,$15,$25,$35,$45,$55,$65,$75,$75,$65,$55,$45,$35,$25,$15,$05
;	DB $0B,$1B,$2B,$3B,$4B,$5B,$6B,$7B,$7B,$6B,$5B,$4B,$3B,$2B,$1B,$0B
;	
;	DB $07,$17,$27,$37,$47,$57,$67,$77,$77,$67,$57,$47,$37,$27,$17,$07
;	DB $08,$18,$28,$38,$48,$58,$68,$78,$78,$68,$58,$48,$38,$28,$18,$08
;	DB $05,$15,$25,$35,$45,$55,$65,$75,$75,$65,$55,$45,$35,$25,$15,$05
;	DB $0B,$1B,$2B,$3B,$4B,$5B,$6B,$7B,$7B,$6B,$5B,$4B,$3B,$2B,$1B,$0B
;
;	DB $0B,$0B,$1B,$1B,$2B,$2B,$3B,$3B,$4B,$4B,$5B,$5B,$6B,$6B,$7B,$7B
;	DB $7B,$7B,$6B,$6B,$5B,$5B,$4B,$4B,$3B,$3B,$2B,$2B,$1B,$1B,$0B,$0B
;	DB $0B,$0B,$1B,$1B,$2B,$2B,$3B,$3B,$4B,$4B,$5B,$5B,$6B,$6B,$7B,$7B
;	DB $7B,$74,$6B,$64,$5B,$54,$4B,$44,$3B,$34,$2B,$24,$1B,$14,$0B,$04
;	
;	DB $04,$04,$14,$14,$24,$24,$34,$34,$44,$44,$54,$54,$64,$64,$74,$74
;	DB $74,$74,$64,$64,$54,$54,$44,$44,$34,$34,$24,$24,$14,$14,$04,$04
;	DB $04,$04,$14,$14,$24,$24,$34,$34,$44,$44,$54,$54,$64,$64,$74,$74
;	DB $74,$74,$64,$64,$54,$54,$44,$44,$34,$34,$24,$24,$14,$14,$04,$04
;	
;colors
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;	DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	
	
	;ALIGN 256
	;	 

;	DB $5A,$59,$57,$56,$55,$54,$53,$51,$50,$4F,$4D,$4C,$4A,$49,$47,$46
;	DB $44,$42,$41,$3F,$3D,$3C,$3A,$38,$37,$35,$33,$32,$30,$2E,$2C,$2B
;	DB $29,$27,$26,$24,$22,$21,$1F,$1D,$1C,$1A,$19,$17,$16,$14,$13,$12
;	DB $10,$0F,$0E,$0D,$0C,$0A,$09,$08,$07,$06,$06,$05,$04,$03,$03,$02
;	DB $02,$01,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
;	DB $01,$02,$02,$03,$03,$04,$05,$06,$06,$07,$08,$09,$0A,$0C,$0D,$0E
;	DB $0F,$10,$12,$13,$14,$16,$17,$19,$1A,$1C,$1D,$1F,$21,$22,$24,$26
;	DB $27,$29,$2B,$2C,$2E,$30

	if STANDALONE=1
m_shift = 40+28
makes_charmap
	include "makes_charmap.asm"
	ORG $3600
	include "data_plasma_sinus.asm"
	
	ORG $3800+(40+28)*8
	include "makes_charset.asm"
	
	ORG $3F00
	include "data_plasma_chars.asm"
	endif
	