	;
	; The Squares part.
	;
STANDALONE=0

	if STANDALONE=1
	ORG $1001-2
	DW  $1001
	
	DW $100B,0
	DB $9E,"4109",0,0,0
	else
	;ALIGN 256
	endif
	
line_count		= $D0
square_flash_count	= $D1
square_status_count	= $D2
square_status		= $D3
;raster_flash1_count	= $D4

sq_fade_pos		= $D8
;
; const
square_size = 35 * 2
sqchar = $BF
sqpos = $0EBC

; start
squares_start
	;---
	if STANDALONE=1
	SEI
	STA $FF3F
	;
	LDA #$03
	LDY #$00
	LDX #$00
sqdelay	INX
	BNE sqdelay
	INY
	BNE sqdelay
	SEC
	SBC #$01
	BNE sqdelay
	;
	LDA #$00
	STA $FF12
	LDA #$38
	STA $FF13
	;
	LDX #Channel1_Square & 255	; init music
	LDY #Channel1_Square >> 8
	JSR set_ch1
	;
	LDX #Channel2_Square & 255
	LDY #Channel2_Square >> 8
	JSR set_ch2
	;
	JSR PLAYER_FREQ_INIT
	;
	endif
	;---
	;
	LDY #$3F	; turn the screen of and set border to green
	JSR screen_off_2
	;
	LDA #$3F	; also set the background
	STA $FF15
	LDY #$08
	;LDX #$00
	JSR fill3	; fill color memory with green
	;
	;LDY #$0A
	;LDX #$01
	;JSR fill
	;
	LDA #$44	; space character
	;LDY #$0C
	LDX #$03
	JSR fillc	; clear the screen
	;
	LDA $FF07
	AND #$40
	BEQ squares_pal	; NTSC adjustment
	;
	LDX #$04	; repeat only 5 times
	STX repeat+1
	;LDX #$04	; top line to sync
	STX squares_top_sync+1
	;
squares_pal
	ORA #$88
	STA $FF07   
	;
	LDA #sqchar		; draw the square
	LDY #$00
	JSR sq_draw		; draw top line
	;
	LDX #sqchar+3		; draw the two sides
	STX sqpos+40
	STX sqpos+80
	STX sqpos+120
	STX sqpos+160
	INX   
	INX
	STX sqpos+44
	STX sqpos+84
	STX sqpos+124
	STX sqpos+164
	;
	LDA #sqchar+6		; draw bottom line of square
	LDY #200
	JSR sq_draw
	;
	; ----------------------------
	;
allwe_width = $1A
allwe_pos = $0C01
	;
	LDX #allwe_width-1		; copy text onto screen (not visible, green on green)
sqcopy1	LDA makes_charmap+$49+164*0,x
	STA allwe_pos,x
	LDA makes_charmap+$49+164*1,x
	STA allwe_pos+40,x
	LDA makes_charmap+$49+164*2,x
	STA allwe_pos+80,x
	;
	DEX
	BPL sqcopy1
	;
	; ---------------------
	;
	JSR sync_bottom		; sync to bottom of screen...
	;
	LDA #$1B		; ...and turn the screen on
	STA $FF06
	;
	JSR sq_fade1		; fade in top text
	;
	LDX #sqpos & 255
	LDY #(sqpos-$0400) >> 8
	;
	JSR sq_fade		; fade in square
	;
	; ---
	;
	LDA #$CA		; DEX opcode (so fade goes backwards)
	STA sf5
	;
	LDA #raster_flash1_end-raster_flash1+$1B+$1A - 1
	STA sq_fade_start+1	; self-mod
	;
	JSR sq_fade1		; hide ("unfade") top text
	;
	JMP sq_go		; continue
	;
sq_draw
	STA sqpos,y		; places 5 chars on screen
	CLC
	ADC #$01
	STA sqpos+1,y
	STA sqpos+2,y
	STA sqpos+3,y
	CLC
	ADC #$01
	STA sqpos+4,y
	RTS
	;
	; ###################################################
	; 
sq_fade1
	LDX #$00		; position of top text
	LDY #$08
	;
sq_fade
	STX sq_fade_pos
	STY sq_fade_pos+1
	;
sq_fade_start
	LDX #$1B
	STX square_flash_count
	;
sf2	JSR sync_cc
	;
	LDX square_flash_count
	LDY #$00
	;
sf1	LDA raster_flash1-$1B,x
	STA sf_a+1
	STX sf_x+1  
	;
	LDX #$05
sf_a	LDA #$00
	STA (sq_fade_pos),y
	TYA
	CLC
	ADC #40
	TAY       
	;
	DEX
	BPL sf_a
	;
	TYA
	SEC
	SBC #240
	TAY
	;         
sf_x	LDX #$00
	DEX
	INY
	CPY #$1B
	BNE sf1
	;                     
	LDX square_flash_count
	CPX #raster_flash1_end-raster_flash1+$1B+$1A
	BEQ sf3
	CPX #$1A
	BEQ sf3
sf5	INX
	STX square_flash_count
	JMP sf2
	;
sf3	; =========
	;
	; simply delay for 40 frames, so changes match music
	LDY #40
sf_delay
	JSR sync_cc
	JSR sync_bottom
	;
	DEY
	BPL sf_delay
	;
	RTS
	
square_flash
	DB $1B
	DB $00,$1B,$1B,$1B,$1B,$1B,$1B,$1B
	DB $00,$1B,$1B,$1B,$1B,$1B,$1B
	DB $00,$1B,$1B,$1B,$1B,$1B
	DB $00,$1B,$1B,$1B,$1B
	DB $00,$1B,$1B,$1B
	DB $00,$1B,$1B
	DB $00,$1B
	DB $00,$00,$1B
	DB $00,$00,$00,$1B
	DB $00,$00,$00,$00,$1B
	DB $00,$00,$00,$00,$00,$1B
	DB $00,$00,$00,$00,$00,$00,$1B
	DB $00,$00,$00,$00,$00,$00,$00,$1B
	DB $00     
square_flash_end
	;

	; define constants for time position table
	; each byte is a two-byte opcode that takes
	; 2-6 cycles          
	;
	; X is always zero
	;
cycle2	= $A9 ; 2 cycles - LDA #$##
cycle3	= $24 ; 3 cycles - BIT $##
cycle4	= $B5 ; 4 cycles - LDA $##,X
cycle5	= $06 ; 5 cycles - ASL $##
cycle6	= $16 ; 6 cycles - ASL $##,X

time_pos	
	DB cycle2, cycle2, cycle2, cycle2, cycle2, 0,0,0	; 10
	
	DB cycle3, cycle2, cycle2, cycle2, cycle2, 0,0,0	; 11
	DB cycle4, cycle2, cycle2, cycle2, cycle2, 0,0,0
	DB cycle5, cycle2, cycle2, cycle2, cycle2, 0,0,0
	DB cycle6, cycle2, cycle2, cycle2, cycle2, 0,0,0
	
	DB cycle6, cycle3, cycle2, cycle2, cycle2, 0,0,0	; 15
	DB cycle6, cycle4, cycle2, cycle2, cycle2, 0,0,0
	DB cycle6, cycle5, cycle2, cycle2, cycle2, 0,0,0
	DB cycle6, cycle6, cycle2, cycle2, cycle2, 0,0,0
	
	DB cycle6, cycle6, cycle3, cycle2, cycle2, 0,0,0	; 19
	DB cycle6, cycle6, cycle4, cycle2, cycle2, 0,0,0
	DB cycle6, cycle6, cycle5, cycle2, cycle2, 0,0,0
	DB cycle6, cycle6, cycle6, cycle2, cycle2, 0,0,0
	
	DB cycle6, cycle6, cycle6, cycle3, cycle2, 0,0,0	; 23
	DB cycle6, cycle6, cycle6, cycle4, cycle2, 0,0,0
	DB cycle6, cycle6, cycle6, cycle5, cycle2, 0,0,0
	DB cycle6, cycle6, cycle6, cycle6, cycle2, 0,0,0
	
	DB cycle6, cycle6, cycle6, cycle6, cycle3, 0,0,0	; 27
	DB cycle6, cycle6, cycle6, cycle6, cycle4, 0,0,0
	DB cycle6, cycle6, cycle6, cycle6, cycle5, 0,0,0
	DB cycle6, cycle6, cycle6, cycle6, cycle6, 0,0,0	; 30
	
	;
	; ---------------------
	;              
	if STANDALONE=1
	ALIGN 256
	DS 10
	endif
	
sq_go
	SEI
	;
	LDA #$00
	STA square_flash_count 
	STA square_status
	STA square_status_count
	;
	;JMP sync0
	;        
	;
sync0	
	LDX square_flash_count
	LDA square_flash,x
	STA $FF06         
	BEQ screen_is_off
	;
	JMP screen_is_on
	;             
screen_is_off
squares_top_sync
	LDA #$12
sync1	CMP $FF1D
	BNE sync1
	;
r4_snr4_c0
	LDA $FF1E
	CMP #$D0
	BCC r4_snr4_c0	; FF1E will be in $D0-$E0 range
	;
	CMP #$E0	; 2
	BEQ r4_snc9	; 2 ; 3 if taken = 5  + 8 ahead = 13
	CMP #$DE	; 2
	BEQ r4_snc8	; 2 ; 3 if taken = 9  + 7 ahead = 16
	CMP #$DC	; 2
	BEQ r4_snc7	; 2 ; 3 if taken = 13 + 6 ahead = 19
	CMP #$DA	; 2
	BEQ r4_snc6	; 2 ; 3 if taken = 17 + 5 ahead = 22
	CMP #$D8	; 2
	BEQ r4_snc5	; 2 ; 3 if taken = 21 + 4 ahead = 25
	CMP #$D6	; 2
	BEQ r4_snc4	; 2 ; 3 if taken = 25 + 3 ahead = 28 / needs 9
	CMP #$D4	; 2
	BEQ r4_snc3	; 2 ; 3 if taken = 29 + 2 ahead = 31 / needs 6
	CMP #$D2	; 2
	BEQ r4_snc2	; 2 ; 3 if taken = 33 + 1 ahead = 34 / needs 3
	CMP #$D0	; 2
	BEQ r4_snr4_c1	; 2 ; 3 if taken = 37
r4_snc9	BIT $EA
r4_snc8	BIT $EA
r4_snc7	BIT $EA
r4_snc6	BIT $EA
r4_snc5	BIT $EA
r4_snc4	BIT $EA
r4_snc3	BIT $EA
r4_snc2	BIT $EA	; 3
r4_snr4_c1
	;
	LDX #$00
	;
	ASL $06
	ASL $06
	ASL $06
	NOP
	NOP
	NOP
	NOP
	;
time1	ASL $06		; these 5 two-byte instructions will be self-modified
time2	LDA #$06	; they will skip from 10-30 cycles to control horizontal positioning
time3	LDA #$06
time4	LDA #$06
time5	LDA #$06
	;
	LDA #$FF
	STA last_size+1
	;
first_size
	LDY #$01
	;
repeat	LDA #$05	; loop runs 6 times (5 on NTSC)
	STA line_count
sq_loop	
loop_start1
raster_ptr
	LDA raster1,y
	LDX raster2,y
	
	STA $FF19	; 4
	ASL $06		; 5
	
	STX $FF19	; 4
	ASL $06		; 5 - pattern repeats horizontally after 18
	
	STA $FF19	; 4
	ASL $06
	
	STX $FF19
	ASL $06
	
	STA $FF19	; 4
	ASL $06
	
	STX $FF19
	ASL $06
	
	STA $FF19	; 4
	ASL $06
	
	STX $FF19
	ASL $06
	
	STA $FF19	; 4
	ASL $06
	
	STX $FF19
	ASL $06
	
	STA $FF19
	
	DEY
last_size
	CPY #$FF
	BNE loop_start1	; 3 taken
	;
	; ---
	;
	LDA #$FF	; solid middle line
	NOP
	STA $FF19	; 4
	;
	ASL $06
	ASL $06
	ASL $06
	ASL $06
	
	ASL $06
	ASL $06
	ASL $06
	ASL $06
	
	ASL $06
	ASL $06
	ASL $06
	ASL $06
	
	ASL $06
	NOP
	NOP
	NOP
	;
	LDY #square_size
	;
	DEC line_count
	LDA line_count		; 2
	CMP #$01		; 2
	BNE not_last_line	; 3, branch taken
	;                            
last_size_value
	;			; -1 for branch not taken
	;LDA #square_size-1	; 2
	LDA #$00
	STA last_size+1		; 4
	JMP cont1		; 3 (+8 total)
	;
not_last_line   
	NOP			; +8 for other condition
	NOP                     
	NOP
	NOP
cont1
	LDA line_count 
	BEQ sq_loop_end
	JMP sq_loop
	
sq_loop_end
	LDA #$3F
	STA $FF19
	;
	; ---
	; status control,
	; this takes care of the progession of the part
	;
	INC square_status_count
	LDA square_status_count
	CMP #$C0
	BNE sq_st_end
	;
	LDA #$00
	STA square_status_count
	;
	INC square_status
	LDA square_status
	CMP #$01
	BEQ sq_st_1
	CMP #$02
	BEQ sq_st_2
	CMP #$04
	BEQ sq_st_4
	CMP #$06
	BEQ sq_st_6
	BNE sq_st_end
	;
sq_st_1	LDA #$EE		; INC $#### opcode
	STA do_horiz_sin
	BNE sq_st_end		; always jump
	;
sq_st_2	LDA #$EE		; INC $#### opcode
	STA do_vert_sin
	BNE sq_st_end		; always jump
	;
sq_st_4	LDA #$CE		; DEC $#### opcode
	STA do_horiz_sin
	STA do_vert_sin
	STA do_vert_sin+3
	BNE sq_st_end		; always jump
	;
sq_st_6	LDA #$EE		; INC $#### opcode
	STA do_horiz_sin
	LDA #$AD		; LDA $#### opcode
	STA do_vert_sin+3
	;BNE sq_st_end		; always jump
	;
sq_st_end     
	; ---
vert_pos
	LDX #$5C
	;
do_vert_sin
	LDA vert_pos+1		; self-mod, will change to INC
	LDA vert_pos+1
	;
	LDA square_v_sin,x
	;
	;LDA first_size+1
	;SEC
	;SBC #$01
	;BPL *+4
	;LDA #square_size
	;
	STA first_size+1
	SEC
	SBC #$01
	STA last_size_value+1
	;
	; ----
horiz_pos       
	LDX #$51		; sinus x start, the looked up value must be 3
	;
do_horiz_sin
	LDA horiz_pos+1		; self-mod, will change to INC
	;
	LDA square_h_sin,x
	BMI hp2
	;
	LDX #raster1 & 255
	STX raster_ptr+1
	LDX #raster2 & 255
	STX raster_ptr+4
	;
	JMP hp3
hp2
	LDX #raster2 & 255
	STX raster_ptr+1
	LDX #raster3 & 255
	STX raster_ptr+4
hp3
	ASL a			; *8
	ASL a
	ASL a
	TAY
	;
	LDA time_pos,y
	STA time1
	LDA time_pos+1,y
	STA time2
	LDA time_pos+2,y
	STA time3
	LDA time_pos+3,y
	STA time4
	LDA time_pos+4,y
	STA time5
	;                 
	; ---
	;
	LDA square_status
	CMP #$03
	BNE rf2
	;        
	; --- status 3: fade to yellow checkerboard pattern
	;
raster_flash1_count
	LDX #$00    
	;
	LDY raster_flash1_count+1
	CPY #raster_flash1_end-raster_flash1-1
	BEQ *+3
	INY
	STY raster_flash1_count+1 
	;
	LDA raster_flash1,x	; get one color
	LDX #35-1		; copy all over one box
rf1	STA raster1,x     
	STA raster3,x
	DEX
	BPL rf1
rf2	;
	; --- status 5: paint rasters
	;
	LDA square_status
	CMP #$05
	BNE rf3
	;
	LDA square_status_count
	LSR a
	CMP #35
	BCS rf3
	;
	STA m35+1
	TAX
	;
	LDA raster1_colors,x
	STA raster1,x
	STA raster3,x
	;
	LDA #34
	SEC
m35	SBC #$00
	TAX
	LDA raster2_colors,x
	STA raster2,x
	STA raster4,x
	;
rf3	;
	;
	; --- status 8: erase it all (with color $FF)
	;             
	LDA square_status
	CMP #$07
	BNE rf_10
	;
	LDX square_status_count
rf_11	CPX #$A9		; add a few frames: this adjust the cut between parts
	BNE rf_10		; so the music is on time
	LDX #$BF		; set timer back
	STX square_status_count
	;STX rf_11+1		; self-mod, this way, the above check only happens once
	;
rf_10	CMP #$08
	BNE rf4
	;
	LDA square_status_count
	SEC
	SBC #$7A		; $C0-35*2 = $7A
	LSR a
	CMP #35
	BCS rf4
	;
	STA m35_2+1
	TAX
	;
	LDA #$FF
	STA raster1,x
	STA raster3,x
	;
	LDA #34
	SEC
m35_2	SBC #$00
	TAX
	LDA #$FF
	STA raster2,x
	STA raster4,x
	;
rf4 	
	LDA square_status
	CMP #$09
	BNE rf5
	;       
	JMP do_final_fade
	;
rf5
	;
	;
	; ##################
	;                   
square_end_of_screen
	;
	JSR PLAYER
	JSR space_check
	;
	LDX square_flash_count
	CPX #square_flash_end-square_flash-1
	BEQ sq_x
	INX
	STX square_flash_count 
	;
sq_end	JMP sync0
	
sq_x	LDA square_status		; only for status 0 (square+grid flash)
	BNE sq_end
	LDA square_status_count
	CMP #$34			; this makes the movement kick in "faster" (on time with music)
	BNE sq_end
	;
	;JMP *
	LDA #$BF			; force status count to $C0 (max)
	STA square_status_count
	BNE sq_end
	
screen_is_on
sync0a	LDA #$12
sync1a	CMP $FF1D
	BNE sync1a
	;
	LDA #$1B
	STA $FF06
	;
	LDA #$CC
sync2a	CMP $FF1D
	BNE sync2a
	;
	JMP square_end_of_screen

	;ALIGN 256
square_h_sin
	include "dat_square_h_sin_hex.asm"
square_v_sin
	include "dat_square_v_sin_hex.asm"
	;
	; ---
	;
	DB $00
raster1
	DB $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F, $3F,$3F,$3F,$3F,$3F,$3F,$3F
	DB $3F,$3F,$3F,$3F,$3F
	DB $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F, $3F,$3F,$3F,$3F,$3F,$3F,$3F

	DB $FF
raster2
	DB $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F, $3F,$3F,$3F,$3F,$3F,$3F,$3F
	DB $3F,$3F,$3F,$3F,$3F
	DB $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F, $3F,$3F,$3F,$3F,$3F,$3F,$3F
	
	DB $FF
raster3
	DB $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F, $3F,$3F,$3F,$3F,$3F,$3F,$3F
	DB $3F,$3F,$3F,$3F,$3F
	DB $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F, $3F,$3F,$3F,$3F,$3F,$3F,$3F
	
	DB $FF

raster4	
	DB $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F, $3F,$3F,$3F,$3F,$3F,$3F,$3F
	DB $3F,$3F,$3F,$3F,$3F
	DB $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F, $3F,$3F,$3F,$3F,$3F,$3F,$3F
	;
raster_flash1
	DB     $3F,$4F,$3F
	DB $4F,$4F,$4A,$4F
	DB $4A,$4A,$5A,$4A
	DB $5A,$5A,$6A,$5A
	DB $6A,$6A,$67,$6A
	DB $67,$67,$69
	DB $7F,$7F,$7A,$7F
	DB $7A,$7A,$77,$7A
	DB $77
raster_flash1_end
	DB $71,$71,$71,$71, $71,$71,$71,$71, $71,$71,$71,$71, $71,$71,$71,$71
	DB $71,$71,$71,$71, $71,$71,$71,$71, $71,$71,$71
	
final_square_fade
	DB $06,$16,$16,$26,$26,$36,$36,$46,$46,$56,$53,$5C,$5C,$6C,$6C,$6F,$6F
final_square_fade_end

do_final_fade
	JSR play_only
	;
	LDA #final_square_fade & 255
	LDX #final_square_fade >> 8
	;
	LDY #final_square_fade_end - final_square_fade - 1
	JSR fullscreen_fade
	;
	if STANDALONE=1 
	JMP $FFF6
	else
	JMP notes2_start
	endif

raster1_colors
	DB $0F,$0F,$1F,$1F,$2F,$2F,$3F,$3F, $4F,$4F,$5F,$4F,$5F,$5F,$6F
	DB $5F,$6F,$6F,$6F,$5F
	DB $6F,$5F,$5F,$4F,$5F,$4F,$4F,$3F, $3F,$2F,$2F,$1F,$1F,$0F,$0F
raster2_colors
	DB $07,$17,$27,$37,$17,$27,$37,$47, $27,$37,$47,$57,$37,$47,$57,$67
	DB $67,$67,$67
	DB $67,$57,$47,$37,$57,$47,$37,$27, $47,$37,$27,$17,$37,$27,$17,$07
	;
	; ---
	;
	if STANDALONE=1 
	include "!player.asm"
	include "player_init.asm"
	include "music.asm"
	
	ALIGN 256
all_over
	RTS
	include "common1.asm"
	include "common2.asm"
	
m_shift = 40+28
makes_charmap
	include "makes_charmap.asm"
	
	ORG $3800
plink_charset
	include "plink_charset.asm"
	
	include "data_circles_charset.asm"
	
	include "makes_charset.asm"
	
	include "data_one_square.asm"
	
plink_charmap
	include "plink_charmap.asm"
	endif
	