	;
	; The tester routine
	; 
	; When testing is enabled, the code will
	; compile to >$4000, so it cannot run on a C=16
	;
	; The purpose was to keep track of free memory
	; and to make sure IRQs were on the same page
	; (because only $FFFE, the low byte is set)
	;
Print	macro text
	JSR $FF4F
	DB text,0
	endm

Print16	macro addr
	Print "$"
	LDA #addr >> 8
	JSR $FB10
	LDA #addr & 255
	JSR $FB10
	JSR $FF4F
	DB " ",0
	endm

CheckIRQS	macro addr1, addr2, text
	LDA #addr1 >> 8
	CMP #addr2 >> 8
	BEQ Test\?
	;
	JSR $FF4F
	DB $D
	DB text
	DB " IRQS NOT ON SAME PAGE!",$D,0
	;
	LDA #addr1 >> 8
	JSR $FB10
	LDA #addr1 & 255
	JSR $FB10
	;
	LDA #$20
	JSR $FFD2
	;
	LDA #addr2 >> 8
	JSR $FB10
	LDA #addr2 & 255
	JSR $FB10
	;               
Test\?
	endm
	
CheckPage	macro addr, lowbyte, text
	LDA #addr & 255
	CMP #lowbyte
	BCC Test\?
	;
	Print $D
	Print text
	Print " ON PAGE BREAK: "
	Print16 addr
Test\?
	endm


test_start	
	Print "DIGI END....: "
	Print16 digi_end
	;      
	Print $D
	Print "FREE START..: "
	Print16 free_start
	;
	Print $D
	Print "FINAL END...: "
	Print16 final_end
	;
	; ---                                         
	CheckPage color_sinus, $80, "COLOR SINUS"
	CheckPage circle_sinus, $C0, "CIRCLE SINUS"
	CheckPage sq_go, $20, "SQ GO"
	CheckPage raster1, $80, "SQUARE RASTER"
	CheckPage legion_logo_data, $FF-(5*22), "LEGION LOGO"
	;
	CheckIRQS irq1, irq2, "PLINK"
	CheckIRQS irq_legion1, irq_legion2, "LEGION"
	CheckIRQS music_only_irq1, music_only_irq2, "MUSIC ONLY"
	CheckIRQS plasma_irq_1, plasma_irq_2, "PLASMA"
	CheckIRQS notes_irq_1, notes_irq_2, "NOTES"
	;
	STA $FF3F
	;       
	LDA #$03
	LDY #$00
	LDX #$00
delay	INX
	BNE delay
	INY
	BNE delay
	SEC
	SBC #$01
	BNE delay
	;
	; --- fill low mem with $AA pattern, to make sure the demo doesn't touch it
	;
	LDA #$AA
	LDX #$00
xx1	STA $0200,x
	STA $0300,x
	STA $0400,x
	STA $0500,x
	STA $0600,x
	STA $0700,x
	INX
	BNE xx1
	;
	LDA #$78
	STA $0200
	LDA #$4C 	; place jmp $FFF6 to $0200
	STA $0201
	LDA #$01
	STA $0202
	LDA #$02
	STA $0203
	;
	LDX #$02
	LDA #$99
xx2	STA $0002,x	; fill zeropage variables with garbage, for testing
	INX
	BNE xx2
	;
	RTS
	